





// Testbench for flipflop module

`timescale 1ns/1ps

module tb_flipflop;

  // Inputs
  reg D_1;
  reg f_clk;
  reg en;
  reg rst;
  
  // Outputs
  wire Q_1;
  wire Q_2;
  wire Q_3;
  wire O;
  wire Q_3_neg;
  

  // Instantiate the module under test
  flipflop uut (
    .D_1(D_1),
    .f_clk(f_clk),
    .rst(rst),
    .en(en),
     .O(O)
 
  );

  // Clock generation
  initial begin
    f_clk = 0;
    forever #1 f_clk = ~f_clk; // Assuming a 1ns clock period
  end

  /// Stimulus generation
  initial begin
    rst = 1;
    en = 1;
    D_1 = 0;
    #10
    rst = 0;
    //forever #10 D_1 = ~D_1;
    
    #10 D_1 = 1;
    #10 D_1 = 0;
    #10 D_1 = 1;
    #10 D_1 = 0;
    #10 D_1 = 1;
    #5  D_1 = 0;
    #5  D_1 = 1;
    #5  D_1 = 0;
    #5  D_1 = 1;
    #5  D_1 = 0;
    #5  D_1 = 1;
    #5  D_1 = 0;
    #5  D_1 = 1;
    #5  D_1 = 0;
    #5  D_1 = 1;
    #2  D_1 = 0;
    #2  D_1 = 1;
    #2  D_1 = 0;
    #2  D_1 = 1;
    #2  D_1 = 0;
    #2  D_1 = 1;
    #2  D_1 = 0;
    #2  D_1 = 1;
    #2  D_1 = 0;
    #2  D_1 = 1;    
    #2  D_1 = 0;
    #2  D_1 = 1;    
    #20  D_1 = 0;
    #20  D_1 = 1;    
    #20  D_1 = 0;
    #20  D_1 = 1;    
    #20  D_1 = 0;
    #20  D_1 = 1;    
    #20  D_1 = 0;
    #20  D_1 = 1;   
    #10 D_1 = 1;
    #10 D_1 = 0;
    #10 D_1 = 1;
    #10 D_1 = 0;
    #10 D_1 = 1; 
    #5 D_1 = 1;
    #8 D_1 = 0;
    #12 D_1 = 1;
    #6 D_1 = 0;
    #3 D_1 = 1;
        #10 D_1 = 1;
    #10 D_1 = 0;
    #10 D_1 = 1;
    #10 D_1 = 0;
    #10 D_1 = 1;
    #5  D_1 = 0;
    #5  D_1 = 1;
    #5  D_1 = 0;
    #5  D_1 = 1;
    #5  D_1 = 0;
    #5  D_1 = 1;
    #5  D_1 = 0;
    #5  D_1 = 1;
    #5  D_1 = 0;
    #5  D_1 = 1;
    #2  D_1 = 0;
    #2  D_1 = 1;
    #2  D_1 = 0;
    #2  D_1 = 1;
    #2  D_1 = 0;
    #2  D_1 = 1;
    #2  D_1 = 0;
    #2  D_1 = 1;
    #2  D_1 = 0;
    #2  D_1 = 1;    
    #2  D_1 = 0;
    #2  D_1 = 1;    
    #20  D_1 = 0;
    #20  D_1 = 1;    
    #20  D_1 = 0;
    #20  D_1 = 1;    
    #20  D_1 = 0;
    #20  D_1 = 1;    
    #20  D_1 = 0;
    #20  D_1 = 1;   
    #10 D_1 = 1;
    #10 D_1 = 0;
    #10 D_1 = 1;
    #10 D_1 = 0;
    #10 D_1 = 1; 
    #5 D_1 = 1;
    #8 D_1 = 0;
    #12 D_1 = 1;
    #6 D_1 = 0;
    #3 D_1 = 1;

  end
endmodule