`timescale 1ns / 1ps
 
module flipflop(
    input wire D_1, //vhod prvi ff
    input wire f_clk, //clock
    input wire rst, //reset
    input wire en, //enable
    output reg O //izhod AND vrat
);
parameter N = 24;
reg [N-1:0] SR = 0, SR_next = 0; //shift register
reg [1:0] SR_2 = 2'b11; //drugi shift register
reg SR_set = 1, SR_en;
reg [N-1:0] Q_4; //shift register izhod
reg Q_1;
reg Q_2;
reg Q_3;
reg Q_3_neg; //negirana vrednost izhoda detektorja
reg [15:0] counter = 0;
reg [15:0] counter_reg = 0;
reg [4:0] shift_counter = 0;
reg [16:0] counter8ciklov = 0;

    always @(posedge f_clk or posedge rst) begin
        if (rst) begin
            Q_1 <= 0;
        end
        else if (en) begin
            Q_1 <= D_1;
        end
    end
    
    
    
        
    always @(posedge f_clk or posedge rst) begin
        if (rst) begin
            Q_2 <= 0;
            counter <=0;
            counter_reg <=0;
        end
        else if (en) begin
            Q_2 <= Q_1;
        end
    end
   
   
   
   always @(posedge f_clk) begin
          Q_3 <= Q_2 ; 
          Q_3_neg <=~Q_3;
          O <= Q_2 & ~Q_3;    
    end





always @(posedge f_clk) begin
    if (O) begin
        counter_reg <= counter;
        counter <= 0;
    end else begin
        counter <= counter + 1;
    end
end


//shift register 1

always @(posedge f_clk) begin
if ( SR_set )
begin
SR <= counter_reg;
SR_set <= 0;
end else begin
SR <= SR;
end
end

//shift register 2


always @(posedge f_clk)begin
if(shift_counter == 4'b0001)begin //DODAJ E && tx_busy !!!!!!!!!!!!
SR_en = 1;
end
if(counter8ciklov == 7)begin
SR_en = 0;
end
end

always @(SR)begin
if(shift_counter == 4'b0000)begin
shift_counter <= shift_counter + 4'b0001;
end 
end

always @(posedge f_clk)begin
if(shift_counter >= 4'b0001 && shift_counter <= 4'b1110)begin
shift_counter <= shift_counter+ 4'b0001;
end else begin
if(shift_counter == 4'b1111)begin
shift_counter <= 4'b0000;
end
end

end

always @(posedge f_clk)begin
if(SR_2 != 2'b01) begin
counter8ciklov <= 0;
end
if(shift_counter == 4'b1000 || shift_counter == 4'b1111) begin
SR_2 <= SR_2 +1;
end
if(counter8ciklov < 3'b111 && SR_2 == 2'b01)begin
counter8ciklov <= counter8ciklov +1;
end else begin
if(counter8ciklov ==3'b111 && SR_2 == 2'b01)begin
SR_2 <= SR_2 +2;
counter8ciklov <= 0;
end
end
end

always @(posedge O && SR_2 == 2'b11)begin
SR_set <= 1;
end

endmodule 



module EightBitCounterWithUART (
    input wire clk,
    input wire rst,
    output reg [7:0] count,
    output wire uart_tx_data_vld,
    output wire [7:0] uart_tx_data
);

    reg [7:0] counter_reg;

    always @(posedge clk or posedge rst) begin
        if (rst) begin
            count <= 8'b0;
            counter_reg <= 8'b0;
        end else begin
            count <= counter_reg;
            counter_reg <= counter_reg + 1;
        end
    end

    // Instantiate your UART module
    // Replace UART_MODULE with the actual name of your UART module
    UART_MODULE uart_instance (
        .i_clk(clk),
        .i_rst(rst),
        .i_data(counter_reg),
        .i_shift_en(1'b1),
        .i_uart_tx_busy(), // Connect to your UART module's busy signal
        .o_uart_tx_data_vld(uart_tx_data_vld),
        .o_uart_tx_data(uart_tx_data)
    );

endmodule


